unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Menus, clipbrd;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    General: TTabSheet;
    Wordlists: TTabSheet;
    Input: TMemo;
    Output: TMemo;
    Names: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Preamble: TMemo;
    Actions: TMemo;
    Label3: TLabel;
    TabSheet1: TTabSheet;
    fromtoken: TMemo;
    totoken: TMemo;
    e: TLabel;
    Label5: TLabel;
    Splitter1: TSplitter;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    PopupMenu1: TPopupMenu;
    Selectall1: TMenuItem;
    Copy1: TMenuItem;
    HeaderControl1: THeaderControl;
    Paste1: TMenuItem;
    PopupMenu2: TPopupMenu;
    Copy2: TMenuItem;
    Paste2: TMenuItem;
    Selectall2: TMenuItem;
    Button5: TButton;
    Button6: TButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Help1: TMenuItem;
    OpenfiletoHide1: TMenuItem;
    OpenfiletoUnhide1: TMenuItem;
    SavePlaintext1: TMenuItem;
    SaveCiphertext1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    About1: TMenuItem;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Copy1Click(Sender: TObject);
    procedure Selectall1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Splitter1Moved(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Paste1Click(Sender: TObject);
    procedure Copy2Click(Sender: TObject);
    procedure Paste2Click(Sender: TObject);
    procedure Selectall2Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure OpenfiletoHide1Click(Sender: TObject);
    procedure OpenfiletoUnhide1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
    function getname:string;
    function getphrase:string;
    function getaction:string;
    function isdefined(str:string):integer;
    function howmanycanido(str:string):integer;
    function encode_play(str:string; lengthoflargesttoken:integer):string;
    function getlargesttoken:integer;
    function getnumspaces(str:string):integer;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Unit2;

{$R *.DFM}

const
  newl=chr(13)+chr(10);

function TForm1.getname:string;
var
  NameIdx:integer;
begin
  NameIdx:=random(names.lines.count);
  getname:=names.lines[NameIdx];
end;

function TForm1.getphrase:string;
var
  PhraseIdx:integer;
begin
  PhraseIdx:=random(preamble.lines.count);
  getphrase:=preamble.lines[PhraseIdx];
end;

function TForm1.getaction:string;
var
  ActionIdx:integer;
begin
  ActionIdx:=random(actions.lines.count);
  getaction:=actions.lines[ActionIdx];
end;


function tform1.isdefined(str:string):integer;
var
  i:integer;

begin
  result:=-1;
  for i:=0 to fromtoken.lines.count-1 do
  begin
    if copy(str,1,length(fromtoken.lines[i]))=fromtoken.lines[i] then
    begin
      result:=i;
      break;
    end;
  end;
end;


function howmanyspaces(str:string):integer;
var
 current:integer;
begin
  current:=1;
  while str[current]=' ' do
    current:=current+1;
  result:=current-1;
end;


function tform1.howmanycanido(str:string):integer;
var
 i:integer;
 done:boolean;

begin
  done:=false;
  i:=1;
  while done = false do
  begin
    if ((i=length(str))or(isdefined(copy(str,i+1,999))<>-1)or(copy(str,i+1,1)=' ')) then
      done:=true
    else
      i:=i+1;
    if i>5 then
    begin
      i:=5;
      break;
    end;
  end;
  result:=i;
end;

function tform1.encode_play(str:string; lengthoflargesttoken:integer):string;
var
 doneto:integer;
 numspaces:integer;
 foundfromtoken:integer;
 foundcharcount:integer;

begin
  doneto:=1;
  result:='';
  while doneto <= length(str) do
  begin
    if str[doneto]=' ' then
    begin
      numspaces:=howmanyspaces(copy(str,doneto,999));
      result:=result+'('+getname+' '+getaction+' '+inttostr(numspaces)+' times)'+newl;
      doneto:=doneto+numspaces;
    end
    else
    begin
      foundfromtoken:=isdefined(copy(str,doneto,lengthoflargesttoken));
      if foundfromtoken<>-1 then
      begin
        result:=result+getname+' says "'+totoken.lines[foundfromtoken]+'"'+newl;
        doneto:=doneto+length(fromtoken.lines[foundfromtoken]);
      end
      else
      begin
        {We don't know what the phrase / char is?}
        foundcharcount:=howmanycanido(copy(str,doneto,5));
        result:=result+getname+' '+getphrase+' "'+copy(str,doneto,foundcharcount)+'"'+newl;
        doneto:=doneto+foundcharcount;
      end;
   end;
  end;
  result:=result+newl+'end of scene'+newl;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  i:integer;
  lengthoflargesttoken:integer;
begin
  lengthoflargesttoken:=getlargesttoken;
  randomize;
  output.lines.clear;
  for i:=0 to input.lines.count-1 do
  begin
    output.lines.add(encode_play(input.lines[i], lengthoflargesttoken));
  end;
end;


procedure TForm1.Button2Click(Sender: TObject);

var
  line:integer;
  workingtext:string;
  str:string;
  firstquotepos:integer;
  lengthofquote:integer;
  tokenidx:integer;
  token:string;
  tempstr:string;
  outputstr:string;
  numspaces:integer;
begin
  workingtext:='';
  input.lines.clear;
  for line:=0 to output.lines.count-1 do
  begin
    str:=output.lines[line];
    if str = 'end of scene' then
    begin
      input.lines.add(workingtext);
      workingtext:='';
    end
    else if pos('says "', str)>0 then
    begin
      firstquotepos:=pos('says "', str) + 5;
      lengthofquote:=length(str)-(firstquotepos+1);
      token:=copy(str, firstquotepos+1, lengthofquote);
      tempstr:=totoken.lines[0];
      tokenidx:=totoken.lines.indexof(token);
      if tokenidx > -1 then
        workingtext := workingtext + fromtoken.lines[tokenidx];
    end
    else if pos('"', str) > 0 then
    begin
      firstquotepos:=pos('"', str);
      lengthofquote:=length(str)-(firstquotepos+1);
      outputstr:=copy(str, firstquotepos+1, lengthofquote);
      workingtext := workingtext + outputstr;
    end
    else if copy(str, 1, 1) = '(' then
    begin
      numspaces:=getnumspaces(str);
      workingtext:=workingtext + StringOfChar(' ', numspaces);
    end;
  end;
end;

function TForm1.getlargesttoken: integer;
var
  fromidx:integer;
  tempstr:string;
begin
  result:=0;
  // Workaround to get Delphi to return us the proper line count
  tempstr:=fromtoken.lines[0];
  for fromidx:=0 to fromtoken.lines.count-1 do
  begin
    if length(fromtoken.lines[fromidx]) > result then
      result:=length(fromtoken.lines[fromidx]);
  end;
end;

function TForm1.getnumspaces(str: string): integer;
var
  posfirstspace:integer;
  tempstr:string;
  possecondspace:integer;
begin
  result:=0;
  posfirstspace:=pos(' ', str);
  if posfirstspace > -1 then
  begin
    if str[posfirstspace+1] in ['0'..'9'] then
    begin
      tempstr:=copy(str, posfirstspace+1, 255);
      possecondspace:=pos(' ', tempstr);
      result := strtoint(copy(tempstr, 1, possecondspace-1));
    end
    else
      result:=getnumspaces(copy(str, posfirstspace+1, 255));
  end;
end;

procedure TForm1.Copy1Click(Sender: TObject);
begin
output.CopyToClipboard;
end;

procedure TForm1.Selectall1Click(Sender: TObject);
begin
output.SelectAll;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
headercontrol1.Sections[0].Width:=input.Width;
headercontrol1.Sections[1].Width:=output.Width;

end;

procedure TForm1.Splitter1Moved(Sender: TObject);
begin
headercontrol1.Sections[0].Width:=input.Width;
headercontrol1.Sections[1].Width:=output.Width;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
headercontrol1.Sections[0].Width:=input.Width;
headercontrol1.Sections[1].Width:=output.Width;
end;

procedure TForm1.Paste1Click(Sender: TObject);
begin
output.PasteFromClipboard;
end;

procedure TForm1.Copy2Click(Sender: TObject);
begin
input.CopyToClipboard;
end;

procedure TForm1.Paste2Click(Sender: TObject);
begin
input.PasteFromClipboard;
end;

procedure TForm1.Selectall2Click(Sender: TObject);
begin
input.SelectAll;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
close;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
SaveDialog1.InitialDir:=OpenDialog1.InitialDir;
if savedialog1.Execute then
  input.Lines.SaveToFile(SaveDialog1.FileName);
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
SaveDialog1.InitialDir:=OpenDialog1.InitialDir;
if savedialog1.Execute then
  output.Lines.SaveToFile(SaveDialog1.FileName);

end;

procedure TForm1.OpenfiletoHide1Click(Sender: TObject);
begin
if opendialog1.Execute then
begin
  input.Lines.LoadFromFile(openDialog1.FileName);
  opendialog1.InitialDir:=extractfilepath(opendialog1.filename);
  opendialog1.FileName:='';
end;
end;

procedure TForm1.OpenfiletoUnhide1Click(Sender: TObject);
begin
if opendialog1.Execute then
begin
  output.Lines.LoadFromFile(openDialog1.FileName);
  opendialog1.InitialDir:=extractfilepath(opendialog1.filename);
  opendialog1.FileName:='';
end;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
//  showmessage('http://www.scramdisk.clara.net/');
form2.showmodal;
end;

end.
